// NetServer

using System;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace Network
{
	// the multicast udp sender
	public class NetServer
	{
        private int UDPmaxPktSize = 65000; // maximum size for udp payloads

		private IPAddress groupAddress;
		private IPEndPoint endPointUDP;
		private UdpClient listenUDP;

        public NetServer(string addr, int port)
        {
            this.groupAddress = IPAddress.Parse(addr);
            this.endPointUDP = new IPEndPoint(groupAddress, port);
            this.listenUDP = new UdpClient();
            this.listenUDP.Ttl = 2;
        }

		~NetServer()
		{	
			this.listenUDP.Close();
		}

        public bool sendByte(byte[] bytes, int len, ushort count)
        {
            int offset = 0;
            byte pkttot = (byte)((len / UDPmaxPktSize) + 1);

            MemoryStream ms = new MemoryStream(UDPmaxPktSize + 4); // an ushort and two byte

            for (byte i = 0; i < pkttot; i++)
            {
                ms.Position = 0;
                ms.Write(BitConverter.GetBytes(count), 0, 2);
                ms.WriteByte(pkttot);
                ms.WriteByte(i);

                if (UDPmaxPktSize < bytes.Length - offset)
                    ms.Write(bytes, offset, UDPmaxPktSize);
                else
                    ms.Write(bytes, offset, bytes.Length - offset);
                
                offset += UDPmaxPktSize;

                try
                {
                    this.listenUDP.Send(ms.ToArray(), (int)ms.Position, this.endPointUDP);
                }
                catch (SocketException)
                {
                    return false;
                }
            }

            return true;
        }
        
	}
}